var 
XHR_GET = 'GET',
XHR_POST = 'POST';

function json_parse(text) {
    if(window.JSON) { return JSON.parse(text); }
    return eval( "(" + text + ")" );
}

function XHR(type, request, postdata, success_cb, failure_cb, finish_cb) 
/*: 
    Str 
  * XHR
  * Str + Null
  * (XHR -> Undef) + Undef
  * (XHR -> Undef) + Undef
  * (XHR -> Undef) + Undef
 -> Undef 
*/
{

    var req = new XMLHttpRequest(),

    call_if_present = function(f) 
    /*: (XHR -> Undef) + Undef -> (XHR -> Undef)*/ 
      {
          return function(req) 
          /*: XHR -> Undef */ 
          {
              if(typeof f === 'function') {
                  f(req);
              }
          };
      }

    success = call_if_present(success_cb),
    failure = call_if_present(failure_cb),
    finish = call_if_present(finish_cb);

    if(type !== XHR_GET && type !== XHR_POST) {
        throw new Error("Nonsensical XHR request type: " + type);
    }
    
    req.open(type, request, true);

    req.onreadystatechange = function (e) {
        if(req.readyState === 4) {
            if(req.status === 200) {
                success(req);
            }
            else {
                console.log(req.status + "was the status");
                failure(req);
            }
            finish(req);
        }
    }

    if(type === XHR_POST) {
        req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    }

    req.send(postdata);

}

function dict_to_params(o) 
/*: {#proto: Object, *: Str} */
{
    var params = [];
    for(var f in o) {
        if(o.hasOwnProperty(f)) {
            params.push(f + "=" + o[f]);
        }
    }
    return params.join("&");
}


// A little helper to make DOM nodes out of objects
Object.prototype.toDOM = function() { 
    return document.createTextNode(String(this)); 
}

// Truncate a string (used for long descriptions)
String.prototype.trunc = function(n) {
    return n < 0 || n > this.length ? this : this.substr(0,n) + "..."; 
}

// ADSAFE doesn't have an interval function.  Default to 1 second
ADSAFE.interval = function(todo, time) {
    setInterval(todo, time || 1000);
}


//
// Some DOM usefulness
//
function $(id) 
/*: Str -> HTMLElement */
{ return document.getElementById(id); }

function el(tag) 
/*: Str -> HTMLElement */
{ return document.createElement(tag); }

function klass(el, cls) { 
    el.setAttribute("class",cls);
    return el;
}

function attr(el, attr, val) {
    el.setAttribute(attr, val);
    return el;
}

function with_attrs(elt, attrs) {
    for(var i in attrs) {
        if(attrs.hasOwnProperty(i)) {
            elt.setAttribute(i, attrs[i]);
        }
    }
    return elt;
}

function el_with_attrs(tag, attrs) {
    var elt = el(tag);
    return with_attrs(elt, attrs);
}

function show(el) 
/*: HTMLElement -> Undef */
{ el.style.display = "block"; }

function hide(el) 
/*: HTMLElement -> Undef */
{ el.style.display = "none"; }

function toggle(el) 
/*: HTMLElement -> Undef */
  {
  if(typeof getComputedStyle !== "undefined" &&  
     getComputedStyle(el,null).display === "none" ||
     el.style.display === "none" || 
     typeof el.style.display === "undefined") {
    show(el);
  }
  else { hide(el); } 
}

function toggle_add_link() 
/*: -> Undef */
{ toggle($('add-link-dialogue')); }

function init() 
/*: -> Undef */
{
    all_links();
}

function all_links() {
    var request = "@all-links-url";
    XHR(XHR_POST, request, "", 
        function(r) {
            var links = json_parse(r.responseText);
            draw_links(links);
        });
}

function link_dom(l) {
    var elt = klass(el("div"),"link"),
    main_link = el_with_attrs("a",
                              {href: l.url,
                               "class": "main-link",
                               title: l.caption}),
    under_link = el_with_attrs("a",
                               {"class": "under-link",
                                href: l.url});

    main_link.appendChild(l.desc.trunc(100).toDOM());
    under_link.appendChild(l.url.trunc(50).toDOM());
    elt.appendChild(main_link);
    elt.appendChild(el("br"));
    elt.appendChild(under_link);
    
    return elt;
}

function draw_links(links) {
    for(var i=0; i<links.length; i++) {
        $('links').appendChild(link_dom(links[i]));
    }
}

function add_link(form) {

    var url = $('url-box').value,
    desc = $('desc-box').value,
    request = "@add-link-url",
    data = "";

    if(url && desc) {
        data = dict_to_params({url: url, desc: desc});
    }

    if(data === "") { 
        alert("Please fill in both fields!"); 
        return;
    }

    XHR(XHR_POST, request, data,
        function(r) { 
            var l = json_parse(r.responseText),
            link = link_dom(l);
            $('links').appendChild(link);
        },
        function(r) { },
        function() { });

}

